--- chan_unistim.c.orig	2011-10-11 11:33:06.000000000 -0500
+++ chan_unistim.c	2011-10-11 11:42:22.000000000 -0500
@@ -1489,37 +1727,123 @@
 	return 1;
 }
 
-static int alloc_sub(struct unistim_line *l, int x)
+static void unistim_line_copy(struct unistim_line *dst, struct unistim_line *src)
+{
+	memcpy(dst, src, sizeof(*dst)); /* this over writes the cap ptr, so we have to reset it */
+}
+
+static struct unistim_line *unistim_line_destroy(struct unistim_line *l)
+{
+	if (!l) {
+		return NULL;
+	}
+	ast_free(l);
+	return NULL;
+}
+
+static struct unistim_line *unistim_line_alloc(void)
+{
+	struct unistim_line *l;
+	if (!(l = ast_calloc(1, sizeof(*l)))) {
+		return NULL;
+	}
+	return l;
+}
+
+static int unistim_free_sub(struct unistim_subchannel *sub) {
+	if (unistimdebug)
+		ast_debug(1, "Released sub %d of channel %s@%s\n", sub->subtype, sub->parent->name, sub->parent->parent->name);
+	if (sub->ss_thread != AST_PTHREADT_NULL) {
+		//pthread_kill(sub->ss_thread, SIGURG);
+		//pthread_join(sub->ss_thread, NULL);
+	}
+	ast_mutex_destroy(&sub->lock);
+	ast_free(sub);
+	return 0;
+}
+
+static struct unistim_subchannel *unistim_alloc_sub(struct unistim_device *d, int x)
 {
 	struct unistim_subchannel *sub;
 	if (!(sub = ast_calloc(1, sizeof(*sub))))
-		return 0;
+		return NULL;
 
 	if (unistimdebug)
-		ast_verb(3, "Allocating UNISTIM subchannel #%d on %s@%s ptr=%p\n", x, l->name, l->parent->name, sub);
-	sub->parent = l;
+		ast_verb(3, "Allocating UNISTIM subchannel #%d on %s ptr=%p\n", x, d->name, sub);
+	sub->parent = NULL;
+	sub->ss_thread = AST_PTHREADT_NULL;
 	sub->subtype = x;
-	l->subs[x] = sub;
+	AST_LIST_LOCK(&d->subs);
+	AST_LIST_INSERT_TAIL(&d->subs, sub, list);
+	AST_LIST_UNLOCK(&d->subs);
 	ast_mutex_init(&sub->lock);
-	return 1;
+	return sub;
 }
 
-static int unalloc_sub(struct unistim_line *p, int x)
+static int unistim_unalloc_sub(struct unistim_device *d, struct unistim_subchannel *sub)
 {
-	if (!x) {
-		ast_log(LOG_WARNING, "Trying to unalloc the real channel %s@%s?!?\n", p->name,
-				p->parent->name);
-		return -1;
+	struct unistim_subchannel *s;
+
+	AST_LIST_LOCK(&d->subs);
+	AST_LIST_TRAVERSE_SAFE_BEGIN(&d->subs, s, list) {
+		if (!s)
+			continue;
+		if (s != sub)
+			continue;
+		AST_LIST_REMOVE_CURRENT(list);
+		unistim_free_sub(sub);
 	}
-	if (unistimdebug)
-		ast_debug(1, "Released sub %d of channel %s@%s\n", x, p->name,
-				p->parent->name);
-	ast_mutex_destroy(&p->lock);
-	ast_free(p->subs[x]);
-	p->subs[x] = 0;
+	AST_LIST_TRAVERSE_SAFE_END;
+	AST_LIST_UNLOCK(&d->subs);
 	return 0;
 }
 
+static const char *subtype_tostr(const int type) 
+{
+	switch (type) {
+	case SUB_REAL:
+		return "REAL";
+	case SUB_ONHOLD:
+		return "ONHOLD";
+	case SUB_RING:
+		return "RINGING";
+	case SUB_THREEWAY:
+		return "THREEWAY";
+	}
+	return "UNKNOWN";
+}
+
+static const char *ptestate_tostr(const int type) 
+{
+	switch (type) {
+	case STATE_INIT:
+		return "INIT";
+	case STATE_AUTHDENY:
+		return "AUTHDENY";
+	case STATE_MAINPAGE:
+		return "MAINPAGE";
+	case STATE_EXTENSION:
+		return "EXTENSION";
+	case STATE_DIALPAGE:
+		return "DIALPAGE";
+	case STATE_RINGING:
+		return "RINGING";
+	case STATE_CALL:
+		return "CALL";
+	case STATE_SELECTOPTION:
+		return "SELECTOPTION";
+	case STATE_SELECTCODEC:
+		return "SELECTCODEC";
+	case STATE_SELECTLANGUAGE:
+		return "SELECTLANGUAGE";
+	case STATE_CLEANING:
+		return "CLEARING";
+	case STATE_HISTORY:
+		return "HISTORY";
+	}
+	return "UNKNOWN";
+}
+
 static void rcv_mac_addr(struct unistimsession *pte, const unsigned char *buf)
 {
 	BUFFSEND;
@@ -1545,60 +1869,69 @@
 		case AUTOPROVISIONING_YES:
 			{
 				struct unistim_device *d, *newd;
-				struct unistim_line *newl;
+				struct unistim_line *newl = NULL, *l;
 				if (unistimdebug)
 					ast_verb(0, "New phone, autoprovisioning on\n");
 				/* First : locate the [template] section */
 				ast_mutex_lock(&devicelock);
 				d = devices;
 				while (d) {
-					if (!strcasecmp(d->name, "template")) {
-						/* Found, cloning this entry */
-						if (!(newd = ast_malloc(sizeof(*newd)))) {
-							ast_mutex_unlock(&devicelock);
-							return;
-						}
-
-						memcpy(newd, d, sizeof(*newd));
-						if (!(newl = ast_malloc(sizeof(*newl)))) {
-							ast_free(newd);
-							ast_mutex_unlock(&devicelock);
-							return;
-						}
-
-						memcpy(newl, d->lines, sizeof(*newl));
-						if (!alloc_sub(newl, SUB_REAL)) {
-							ast_free(newd);
-							ast_free(newl);
-							ast_mutex_unlock(&devicelock);
-							return;
+					if (strcasecmp(d->name, "template")) {
+						d = d->next;
+						continue;
+					}
+					/* Found, cloning this entry */
+					if (!(newd = ast_malloc(sizeof(*newd)))) {
+						ast_mutex_unlock(&devicelock);
+						return;
+					}
+					memcpy(newd, d, sizeof(*newd));
+					ast_mutex_init(&newd->lock);
+					newd->lines.first = NULL;
+					newd->lines.last = NULL;
+					AST_LIST_LOCK(&d->lines);
+					AST_LIST_TRAVERSE(&d->lines, l, list) {
+						if (!(newl = unistim_line_alloc())) {
+							break;
 						}
-						/* Ok, now updating some fields */
-						ast_copy_string(newd->id, addrmac, sizeof(newd->id));
-						ast_copy_string(newd->name, addrmac, sizeof(newd->name));
-						if (newd->extension == EXTENSION_NONE)
-							newd->extension = EXTENSION_ASK;
-						newd->lines = newl;
-						newd->receiver_state = STATE_ONHOOK;
-						newd->session = pte;
-						newd->to_delete = -1;
-						pte->device = newd;
-						newd->next = NULL;
+						unistim_line_copy(l, newl);
 						newl->parent = newd;
-						strcpy(newl->name, d->lines->name);
-						snprintf(d->lines->name, sizeof(d->lines->name), "%d",
-								 atoi(d->lines->name) + 1);
+						ast_copy_string(newl->name, l->name, sizeof(newl->name));
 						snprintf(newl->fullname, sizeof(newl->fullname), "USTM/%s@%s",
 								 newl->name, newd->name);
-						/* Go to the end of the linked chain */
-						while (d->next) {
-							d = d->next;
-						}
-						d->next = newd;
-						d = newd;
-						break;
+						snprintf(l->name, sizeof(l->name), "%d", atoi(l->name) + 1);
+
+						AST_LIST_LOCK(&newd->lines);
+						AST_LIST_INSERT_TAIL(&newd->lines, newl, list);
+						AST_LIST_UNLOCK(&newd->lines);
+					}
+					AST_LIST_UNLOCK(&d->lines);
+					if (!newl) {
+						ast_free(newd);
+						ast_mutex_unlock(&devicelock);
+					}
+
+					/* Ok, now updating some fields */
+					ast_copy_string(newd->id, addrmac, sizeof(newd->id));
+					ast_copy_string(newd->name, addrmac, sizeof(newd->name));
+					if (newd->extension == EXTENSION_NONE) {
+						newd->extension = EXTENSION_ASK;
+					}
+
+					newd->receiver_state = STATE_ONHOOK;
+					newd->session = pte;
+					newd->language[0] = '\0';
+					newd->to_delete = -1;
+					newd->next = NULL;
+					pte->device = newd;
+
+					/* Go to the end of the linked chain */
+					while (d->next) {
+						d = d->next;
 					}
-					d = d->next;
+					d->next = newd;
+					d = newd;
+					break;
 				}
 				ast_mutex_unlock(&devicelock);
 				if (!d) {
@@ -1610,17 +1943,28 @@
 		case AUTOPROVISIONING_TN:
 			pte->state = STATE_AUTHDENY;
 			break;
-		case AUTOPROVISIONING_DB:
-			ast_log(LOG_WARNING,
-					"Autoprovisioning with database is not yet functional\n");
-			break;
 		default:
 			ast_log(LOG_WARNING, "Internal error : unknown autoprovisioning value = %d\n",
 					autoprovisioning);
 		}
 	}
 	if (pte->state != STATE_AUTHDENY) {
+		struct unistim_line *line;
+		struct unistim_subchannel *sub;
+		
 		ast_verb(3, "Device '%s' successfuly registered\n", pte->device->name);
+		
+		AST_LIST_LOCK(&pte->device->subs);
+		AST_LIST_TRAVERSE_SAFE_BEGIN(&pte->device->subs, sub, list) {
+			if (sub) {
+				ast_log(LOG_ERROR, "Subchannel lost sice reboot. Hanged channel may apear!\n");
+				AST_LIST_REMOVE_CURRENT(list);
+				ast_free(sub);
+			}
+		}
+		AST_LIST_TRAVERSE_SAFE_END;
+		AST_LIST_UNLOCK(&pte->device->subs);
+		
 		switch (pte->device->extension) {
 		case EXTENSION_NONE:
 			pte->state = STATE_MAINPAGE;
@@ -1631,16 +1975,17 @@
 				pte->state = STATE_EXTENSION;
 			else {
 				/* Yes, because of a phone reboot. We don't ask again for the TN */
-				if (RegisterExtension(pte))
+				if (register_extension(pte))
 					pte->state = STATE_EXTENSION;
 				else
 					pte->state = STATE_MAINPAGE;
 			}
 			break;
 		case EXTENSION_LINE:
-			ast_copy_string(pte->device->extension_number, pte->device->lines->name,
+			line = AST_LIST_FIRST(&pte->device->lines);
+			ast_copy_string(pte->device->extension_number, line->name,
 							sizeof(pte->device->extension_number));
-			if (RegisterExtension(pte))
+			if (register_extension(pte))
 				pte->state = STATE_EXTENSION;
 			else
 				pte->state = STATE_MAINPAGE;
@@ -1725,20 +2070,18 @@
 
 	snprintf(tmp, sizeof(tmp), "%s/%s", ast_config_AST_LOG_DIR, USTM_LOG_DIR);
 	if (ast_mkdir(tmp, 0770)) {
-		if (errno != EEXIST) {
-			display_last_error("Unable to create directory for history");
-			return -1;
-		}
+		ast_log(LOG_WARNING, "Unable to create directory for history");
+                return -1;
 	}
 
 	ast_localtime(&now, &atm, NULL);
 	if (ismissed) {
 		if (way == 'i')
-			strcpy(tmp2, "Miss");
+			ast_copy_string(tmp2, ustmtext("Miss", pte), sizeof(tmp2));
 		else
-			strcpy(tmp2, "Fail");
+			ast_copy_string(tmp2, ustmtext("Fail", pte), sizeof(tmp2));
 	} else
-		strcpy(tmp2, "Answ");
+		ast_copy_string(tmp2, ustmtext("Answ", pte), sizeof(tmp2));
 	snprintf(line1, sizeof(line1), "%04d/%02d/%02d %02d:%02d:%02d %s",
 			 atm.tm_year + 1900, atm.tm_mon + 1, atm.tm_mday, atm.tm_hour,
 			 atm.tm_min, atm.tm_sec, tmp2);
@@ -1856,41 +2199,14 @@
 	return 0;
 }
 
-static void cancel_dial(struct unistimsession *pte)
-{
-	send_no_ring(pte);
-	pte->device->missed_call++;
-	write_history(pte, 'i', 1);
-	show_main_page(pte);
-	return;
-}
-
-static void swap_subs(struct unistim_line *p, int a, int b)
+static void unistim_quiet_chan(struct ast_channel *chan)
 {
-/*  struct ast_channel *towner; */
-	struct ast_rtp_instance *rtp;
-	int fds;
-
-	if (unistimdebug)
-		ast_verb(0, "Swapping %d and %d\n", a, b);
-
-	if ((!p->subs[a]->owner) || (!p->subs[b]->owner)) {
-		ast_log(LOG_WARNING,
-				"Attempted to swap subchannels with a null owner : sub #%d=%p sub #%d=%p\n",
-				a, p->subs[a]->owner, b, p->subs[b]->owner);
-		return;
+	if (chan && chan->_state == AST_STATE_UP) {
+		if (ast_test_flag(chan, AST_FLAG_MOH))
+			ast_moh_stop(chan);
+		else if (chan->generatordata)
+			ast_deactivate_generator(chan);
 	}
-	rtp = p->subs[a]->rtp;
-	p->subs[a]->rtp = p->subs[b]->rtp;
-	p->subs[b]->rtp = rtp;
-
-	fds = p->subs[a]->owner->fds[0];
-	p->subs[a]->owner->fds[0] = p->subs[b]->owner->fds[0];
-	p->subs[b]->owner->fds[0] = fds;
-
-	fds = p->subs[a]->owner->fds[1];
-	p->subs[a]->owner->fds[1] = p->subs[b]->owner->fds[1];
-	p->subs[b]->owner->fds[1] = fds;
 }
 
 static int attempt_transfer(struct unistim_subchannel *p1, struct unistim_subchannel *p2)
@@ -1898,7 +2214,7 @@
 	int res = 0;
 	struct ast_channel
 	 *chana = NULL, *chanb = NULL, *bridgea = NULL, *bridgeb = NULL, *peera =
-		NULL, *peerb = NULL, *peerc = NULL;
+		NULL, *peerb = NULL, *peerc = NULL, *peerd = NULL;
 
 	if (!p1->owner || !p2->owner) {
 		ast_log(LOG_WARNING, "Transfer attempted without dual ownership?\n");
@@ -1913,37 +2229,27 @@
 		peera = chana;
 		peerb = chanb;
 		peerc = bridgea;
+		peerd = bridgeb;
 	} else if (bridgeb) {
 		peera = chanb;
 		peerb = chana;
 		peerc = bridgeb;
+		peerd = bridgea;
 	}
-
+	
 	if (peera && peerb && peerc && (peerb != peerc)) {
-		/*ast_quiet_chan(peera);
-		   ast_quiet_chan(peerb);
-		   ast_quiet_chan(peerc);
-		   ast_quiet_chan(peerd); */
-
-		if (peera->cdr && peerb->cdr) {
-			peerb->cdr = ast_cdr_append(peerb->cdr, peera->cdr);
-		} else if (peera->cdr) {
-			peerb->cdr = peera->cdr;
-		}
-		peera->cdr = NULL;
-
-		if (peerb->cdr && peerc->cdr) {
-			peerb->cdr = ast_cdr_append(peerb->cdr, peerc->cdr);
-		} else if (peerc->cdr) {
-			peerb->cdr = peerc->cdr;
-		}
-		peerc->cdr = NULL;
-
+		unistim_quiet_chan(peera);
+		unistim_quiet_chan(peerb);
+		unistim_quiet_chan(peerc);
+		if (peerd)
+			unistim_quiet_chan(peerd); 
+	    
+		ast_log(LOG_NOTICE, "UNISTIM transfer: trying to masquerade %s into %s\n", peerc->name, peerb->name);
 		if (ast_channel_masquerade(peerb, peerc)) {
 			ast_log(LOG_WARNING, "Failed to masquerade %s into %s\n", peerb->name,
 					peerc->name);
 			res = -1;
-		}
+		} 
 		return res;
 	} else {
 		ast_log(LOG_NOTICE,
@@ -1976,42 +2282,143 @@
 	memcpy(data, callerid, size);
 }
 
-static void close_call(struct unistimsession *pte)
+static struct unistim_subchannel* get_sub(struct unistim_device *device, int type) 
 {
-	struct unistim_subchannel *sub;
-	struct unistim_line *l = pte->device->lines;
+	struct unistim_subchannel *sub = NULL;
 
-	sub = pte->device->lines->subs[SUB_REAL];
-	send_stop_timer(pte);
-	if (sub->owner) {
-		sub->alreadygone = 1;
-		if (l->subs[SUB_THREEWAY]) {
-			l->subs[SUB_THREEWAY]->alreadygone = 1;
-			if (attempt_transfer(sub, l->subs[SUB_THREEWAY]) < 0)
-				ast_verb(0, "attempt_transfer failed.\n");
-		} else
-			ast_queue_hangup(sub->owner);
-	} else {
-		if (l->subs[SUB_THREEWAY]) {
-			if (l->subs[SUB_THREEWAY]->owner)
-				ast_queue_hangup_with_cause(l->subs[SUB_THREEWAY]->owner, AST_CAUSE_NORMAL_CLEARING);
-			else
-				ast_log(LOG_WARNING, "threeway sub without owner\n");
-		} else
-			ast_verb(0, "USTM(%s@%s-%d) channel already destroyed\n", sub->parent->name,
-						sub->parent->parent->name, sub->subtype);
+	AST_LIST_LOCK(&device->subs);
+	AST_LIST_TRAVERSE(&device->subs, sub, list) {
+		if (!sub)
+			continue;
+		if (sub->subtype == type) {
+			break;
+		}
 	}
-	change_callerid(pte, 0, pte->device->redial_number);
-	change_callerid(pte, 1, "");
-	write_history(pte, 'o', pte->device->missed_call);
-	pte->device->missed_call = 0;
-	show_main_page(pte);
-	return;
+	AST_LIST_UNLOCK(&device->subs);
+
+	return sub;
 }
 
-static void IgnoreCall(struct unistimsession *pte)
+static void sub_start_silence(struct unistimsession *pte, struct unistim_subchannel *sub) 
 {
-	send_no_ring(pte);
+	/* Silence our channel */
+	if (!pte->device->silence_generator) {
+		pte->device->silence_generator =
+			ast_channel_start_silence_generator(sub->owner);
+		if (pte->device->silence_generator == NULL)
+			ast_log(LOG_WARNING, "Unable to start a silence generator.\n");
+		else if (unistimdebug)
+			ast_verb(0, "Starting silence generator\n");
+	}
+
+}
+
+static void sub_stop_silence(struct unistimsession *pte, struct unistim_subchannel *sub) 
+{
+	/* Stop the silence generator */
+	if (pte->device->silence_generator) {
+		if (unistimdebug)
+			ast_verb(0, "Stopping silence generator\n");
+		if (sub->owner)
+			ast_channel_stop_silence_generator(sub->owner, pte->device->silence_generator);
+		else
+			ast_log(LOG_WARNING, "Trying to stop silence generator on a null channel !\n");
+		pte->device->silence_generator = NULL;
+	}
+}
+
+static void sub_hold(struct unistimsession *pte, struct unistim_subchannel *sub) 
+{
+	if (!sub) {
+		return;
+	}
+	sub->moh = 1;
+	sub->subtype = SUB_ONHOLD;
+	send_favorite_short(sub->softkey, FAV_ICON_ONHOLD_BLACK + FAV_BLINK_SLOW, pte);
+	send_select_output(pte, pte->device->output, pte->device->volume, MUTE_ON);
+	send_stop_timer(pte);
+	if (sub->owner) {
+		ast_queue_control_data(sub->owner, AST_CONTROL_HOLD, NULL, 0);
+		send_end_call(pte);
+	}
+	return;
+}
+
+static void sub_unhold(struct unistimsession *pte, struct unistim_subchannel *sub) 
+{
+	struct unistim_subchannel *sub_real;
+
+	sub_real = get_sub(pte->device, SUB_REAL);
+	if (sub_real) {
+	    sub_hold(pte, sub_real);
+	}
+
+	sub->moh = 0;
+	sub->subtype = SUB_REAL;
+	send_favorite_short(sub->softkey, FAV_ICON_OFFHOOK_BLACK, pte);
+	send_select_output(pte, pte->device->output, pte->device->volume, MUTE_OFF);
+	send_start_timer(pte);
+	if (sub->owner) {
+		ast_queue_control_data(sub->owner, AST_CONTROL_UNHOLD, NULL, 0);
+		if (sub->rtp)
+			send_start_rtp(sub);
+	}
+	return;
+}
+
+static void close_call(struct unistimsession *pte)
+{
+	struct unistim_subchannel *sub, *sub_transf;
+
+	sub = get_sub(pte->device, SUB_REAL);
+	sub_transf = get_sub(pte->device, SUB_THREEWAY);
+	send_stop_timer(pte);
+	if (!sub) {
+		ast_log(LOG_WARNING, "Close call without sub\n");
+		return;
+	}
+	send_favorite_short(sub->softkey, FAV_LINE_ICON, pte);
+	if (sub->owner) {
+		sub->alreadygone = 1;
+		if (sub_transf) {
+			sub_transf->alreadygone = 1;
+			if (attempt_transfer(sub, sub_transf) < 0)
+				ast_verb(0, "attempt_transfer failed.\n");
+		} else
+			ast_queue_hangup(sub->owner);
+	} else {
+		if (sub_transf) {
+			if (sub_transf->owner)
+				ast_queue_hangup_with_cause(sub_transf->owner, AST_CAUSE_NORMAL_CLEARING);
+			else
+				ast_log(LOG_WARNING, "threeway sub without owner\n");
+		} else {
+			ast_verb(0, "USTM(%s@%s-%d) channel already destroyed\n", sub->parent->name,
+						pte->device->name, sub->softkey);
+		}
+	}        
+	change_callerid(pte, 0, pte->device->redial_number);
+	change_callerid(pte, 1, "");
+	write_history(pte, 'o', pte->device->missed_call);
+	pte->device->missed_call = 0;
+	show_main_page(pte);
+	return;
+}
+
+static void ignore_call(struct unistimsession *pte)
+{
+	send_no_ring(pte);
+	return;
+}
+
+static void discard_call(struct unistimsession *pte)
+{
+	struct unistim_subchannel* sub;
+	sub = get_sub(pte->device, SUB_RING);
+	if (!sub)
+	    return;
+	
+	ast_queue_hangup_with_cause(sub->owner, AST_CAUSE_NORMAL_CLEARING);
 	return;
 }
 
@@ -2023,7 +2430,12 @@
 	struct unistimsession *s = l->parent->session;
 	int res;
 
-	ast_verb(3, "Starting switch on '%s@%s-%d' to %s\n", l->name, l->parent->name, sub->subtype, s->device->phone_number);
+/*      Better to fail, then completely hang a phone in upredictable state
+	if (!s) { 
+		return NULL;
+	}
+*/
+	ast_verb(3, "Starting switch on '%s@%s-%d' to %s\n", l->name, l->parent->name, sub->softkey, s->device->phone_number);
 	ast_copy_string(chan->exten, s->device->phone_number, sizeof(chan->exten));
 	ast_copy_string(s->device->redial_number, s->device->phone_number,
 					sizeof(s->device->redial_number));
@@ -2031,85 +2443,52 @@
 	res = ast_pbx_run(chan);
 	if (res) {
 		ast_log(LOG_WARNING, "PBX exited non-zero\n");
-		send_tone(s, 1000, 0);;
+		send_tone(s, 1000, 0);
 	}
 	return NULL;
 }
 
-static void start_rtp(struct unistim_subchannel *sub)
+static int find_rtp_port(struct unistim_subchannel *s) 
 {
-	BUFFSEND;
+	struct unistim_subchannel *sub = NULL;
+	int rtp_start = s->parent->parent->rtp_port;
+	struct ast_sockaddr us_tmp;
 	struct sockaddr_in us = { 0, };
+
+	AST_LIST_LOCK(&s->parent->parent->subs);
+	AST_LIST_TRAVERSE(&s->parent->parent->subs, sub, list) {
+		if (!sub)
+			continue;
+		if (sub->rtp) {
+			ast_rtp_instance_get_remote_address(sub->rtp, &us_tmp);
+			ast_sockaddr_to_sin(&us_tmp, &us);
+			if (htons(us.sin_port)) {
+				rtp_start = htons(us.sin_port) + 1;
+				break;
+			}
+		}
+	}
+	AST_LIST_UNLOCK(&s->parent->parent->subs);
+	return rtp_start;
+}
+
+static void send_start_rtp(struct unistim_subchannel *sub) 
+{
+	BUFFSEND;
+
+	int codec;
 	struct sockaddr_in public = { 0, };
+	struct sockaddr_in us = { 0, };
 	struct sockaddr_in sin = { 0, };
-	format_t codec;
-	struct sockaddr_in sout = { 0, };
 	struct ast_sockaddr us_tmp;
 	struct ast_sockaddr sin_tmp;
-	struct ast_sockaddr sout_tmp;
+	struct unistimsession *pte;
 
-	/* Sanity checks */
-	if (!sub) {
-		ast_log(LOG_WARNING, "start_rtp with a null subchannel !\n");
-		return;
-	}
-	if (!sub->parent) {
-		ast_log(LOG_WARNING, "start_rtp with a null line !\n");
-		return;
-	}
-	if (!sub->parent->parent) {
-		ast_log(LOG_WARNING, "start_rtp with a null device !\n");
-		return;
-	}
-	if (!sub->parent->parent->session) {
-		ast_log(LOG_WARNING, "start_rtp with a null session !\n");
-		return;
-	}
-	sout = sub->parent->parent->session->sout;
-
-	ast_mutex_lock(&sub->lock);
-	/* Allocate the RTP */
-	if (unistimdebug)
-		ast_verb(0, "Starting RTP. Bind on %s\n", ast_inet_ntoa(sout.sin_addr));
-	ast_sockaddr_from_sin(&sout_tmp, &sout);
-	sub->rtp = ast_rtp_instance_new("asterisk", sched, &sout_tmp, NULL);
-	if (!sub->rtp) {
-		ast_log(LOG_WARNING, "Unable to create RTP session: %s binaddr=%s\n",
-				strerror(errno), ast_inet_ntoa(sout.sin_addr));
-		ast_mutex_unlock(&sub->lock);
-		return;
-	}
-	ast_rtp_instance_set_prop(sub->rtp, AST_RTP_PROPERTY_RTCP, 1);
-	if (sub->owner) {
-		sub->owner->fds[0] = ast_rtp_instance_fd(sub->rtp, 0);
-		sub->owner->fds[1] = ast_rtp_instance_fd(sub->rtp, 1);
-	}
-	ast_rtp_instance_set_qos(sub->rtp, qos.tos_audio, qos.cos_audio, "UNISTIM RTP");
-	ast_rtp_instance_set_prop(sub->rtp, AST_RTP_PROPERTY_NAT, sub->parent->parent->nat);
-
-	/* Create the RTP connection */
 	ast_rtp_instance_get_local_address(sub->rtp, &us_tmp);
 	ast_sockaddr_to_sin(&us_tmp, &us);
-	sin.sin_family = AF_INET;
-	/* Setting up RTP for our side */
-	memcpy(&sin.sin_addr, &sub->parent->parent->session->sin.sin_addr,
-		   sizeof(sin.sin_addr));
-	sin.sin_port = htons(sub->parent->parent->rtp_port);
-	ast_sockaddr_from_sin(&sin_tmp, &sin);
-	ast_rtp_instance_set_remote_address(sub->rtp, &sin_tmp);
-	if (!(sub->owner->nativeformats & sub->owner->readformat)) {
-		format_t fmt;
-		char tmp[256];
-		fmt = ast_best_codec(sub->owner->nativeformats);
-		ast_log(LOG_WARNING,
-				"Our read/writeformat has been changed to something incompatible: %s, using %s best codec from %s\n",
-				ast_getformatname(sub->owner->readformat),
-				ast_getformatname(fmt),
-				ast_getformatname_multiple(tmp, sizeof(tmp), sub->owner->nativeformats));
-		sub->owner->readformat = fmt;
-		sub->owner->writeformat = fmt;
-	}
-	codec = ast_rtp_codecs_payload_code(ast_rtp_instance_get_codecs(sub->rtp), 1, sub->owner->readformat);
+	ast_rtp_instance_get_remote_address(sub->rtp, &sin_tmp);
+	ast_sockaddr_to_sin(&sin_tmp, &sin);
+
 	/* Setting up RTP of the phone */
 	if (public_ip.sin_family == 0)  /* NAT IP override ?   */
 		memcpy(&public, &us, sizeof(public));   /* No defined, using IP from recvmsg  */
@@ -2122,35 +2501,35 @@
 		ast_verb(0, "Starting phone RTP stack. Our public IP is %s\n",
 					ast_inet_ntoa(public.sin_addr));
 	}
+
+	pte = sub->parent->parent->session;
+	codec = ast_rtp_codecs_payload_code(ast_rtp_instance_get_codecs(sub->rtp), 1, sub->owner->readformat);
 	if ((sub->owner->readformat == AST_FORMAT_ULAW) ||
 		(sub->owner->readformat == AST_FORMAT_ALAW)) {
 		if (unistimdebug)
-			ast_verb(0, "Sending packet_send_rtp_packet_size for codec %s\n", ast_getformatname(codec));
+			ast_verb(0, "Sending packet_send_rtp_packet_size for codec %d\n", codec);
 		memcpy(buffsend + SIZE_HEADER, packet_send_rtp_packet_size,
 			   sizeof(packet_send_rtp_packet_size));
 		buffsend[10] = (int) codec & 0xffffffffLL;
-		send_client(SIZE_HEADER + sizeof(packet_send_rtp_packet_size), buffsend,
-				   sub->parent->parent->session);
+		send_client(SIZE_HEADER + sizeof(packet_send_rtp_packet_size), buffsend, pte);
 	}
 	if (unistimdebug)
 		ast_verb(0, "Sending Jitter Buffer Parameters Configuration\n");
 	memcpy(buffsend + SIZE_HEADER, packet_send_jitter_buffer_conf,
 		   sizeof(packet_send_jitter_buffer_conf));
-	send_client(SIZE_HEADER + sizeof(packet_send_jitter_buffer_conf), buffsend,
-			   sub->parent->parent->session);
-	if (sub->parent->parent->rtp_method != 0) {
+	send_client(SIZE_HEADER + sizeof(packet_send_jitter_buffer_conf), buffsend, pte);
+	if (pte->device->rtp_method != 0) {
 		uint16_t rtcpsin_port = htons(us.sin_port) + 1; /* RTCP port is RTP + 1 */
 
 		if (unistimdebug)
-			ast_verb(0, "Sending OpenAudioStreamTX using method #%d\n",
-						sub->parent->parent->rtp_method);
-		if (sub->parent->parent->rtp_method == 3)
+			ast_verb(0, "Sending OpenAudioStreamTX using method #%d\n", pte->device->rtp_method);
+		if (pte->device->rtp_method == 3)
 			memcpy(buffsend + SIZE_HEADER, packet_send_open_audio_stream_tx3,
 				   sizeof(packet_send_open_audio_stream_tx3));
 		else
 			memcpy(buffsend + SIZE_HEADER, packet_send_open_audio_stream_tx,
 				   sizeof(packet_send_open_audio_stream_tx));
-		if (sub->parent->parent->rtp_method != 2) {
+		if (pte->device->rtp_method != 2) {
 			memcpy(buffsend + 28, &public.sin_addr, sizeof(public.sin_addr));
 			buffsend[20] = (htons(sin.sin_port) & 0xff00) >> 8;
 			buffsend[21] = (htons(sin.sin_port) & 0x00ff);
@@ -2169,18 +2548,17 @@
 			buffsend[11] = codec;
 		}
 		buffsend[12] = codec;
-		send_client(SIZE_HEADER + sizeof(packet_send_open_audio_stream_tx), buffsend,
-				   sub->parent->parent->session);
+		send_client(SIZE_HEADER + sizeof(packet_send_open_audio_stream_tx), buffsend, pte);
 
 		if (unistimdebug)
 			ast_verb(0, "Sending OpenAudioStreamRX\n");
-		if (sub->parent->parent->rtp_method == 3)
+		if (pte->device->rtp_method == 3)
 			memcpy(buffsend + SIZE_HEADER, packet_send_open_audio_stream_rx3,
 				   sizeof(packet_send_open_audio_stream_rx3));
 		else
 			memcpy(buffsend + SIZE_HEADER, packet_send_open_audio_stream_rx,
 				   sizeof(packet_send_open_audio_stream_rx));
-		if (sub->parent->parent->rtp_method != 2) {
+		if (pte->device->rtp_method != 2) {
 			memcpy(buffsend + 28, &public.sin_addr, sizeof(public.sin_addr));
 			buffsend[20] = (htons(sin.sin_port) & 0xff00) >> 8;
 			buffsend[21] = (htons(sin.sin_port) & 0x00ff);
@@ -2199,8 +2577,7 @@
 			buffsend[12] = codec;
 		}
 		buffsend[11] = codec;
-		send_client(SIZE_HEADER + sizeof(packet_send_open_audio_stream_rx), buffsend,
-				   sub->parent->parent->session);
+		send_client(SIZE_HEADER + sizeof(packet_send_open_audio_stream_rx), buffsend, pte);
 	} else {
 		uint16_t rtcpsin_port = htons(us.sin_port) + 1; /* RTCP port is RTP + 1 */
 
